searchNodes=[{"doc":"Create Signed URLs for Google Cloud Storage in Elixir","ref":"GcsSignedUrl.html","title":"GcsSignedUrl","type":"module"},{"doc":"If the first argument is a GcsSignedUrl.Client{} : Generate V2 signed url using its private key. If the first argument is a %GcsSignedUrl.SignBlob.OAuthConfig{} : Generate V2 signed url using the Google IAM REST API with a OAuth2 token of a service account. Examples iex&gt; client = % GcsSignedUrl.Client { private_key : &quot;...&quot; , client_email : &quot;...&quot; } iex&gt; GcsSignedUrl . generate ( client , &quot;my-bucket&quot; , &quot;my-object.mp4&quot; , expires : 1503599316 ) &quot;https://storage.googleapis.com/my-bucket/my-object.mp4?Expires=15...&quot; iex&gt; oauth_config = % GcsSignedUrl.SignBlob.OAuthConfig { service_account : &quot;...&quot; , access_token : &quot;...&quot; } iex&gt; GcsSignedUrl . generate ( oauth_config , &quot;my-bucket&quot; , &quot;my-object.mp4&quot; , expires : 1503599316 ) { :ok , &quot;https://storage.googleapis.com/my-bucket/my-object.mp4?X-Goog-Expires=1800...&quot; }","ref":"GcsSignedUrl.html#generate/4","title":"GcsSignedUrl.generate/4","type":"function"},{"doc":"If the first argument is a GcsSignedUrl.Client{} : Generate V4 signed url using its private key. If the first argument is a %GcsSignedUrl.SignBlob.OAuthConfig{} : Generate V4 signed url using the Google IAM REST API with a OAuth2 token of a service account. Examples iex&gt; client = % GcsSignedUrl.Client %{ private_key : &quot;...&quot; , client_email : &quot;...&quot; } iex&gt; GcsSignedUrl . generate_v4 ( client , &quot;my-bucket&quot; , &quot;my-object.mp4&quot; , verb : &quot;PUT&quot; , expires : 1800 , headers : [ &quot;Content-Type&quot; : &quot;application/json&quot; ] ) &quot;https://storage.googleapis.com/my-bucket/my-object.mp4?X-Goog-Expires=1800...&quot; iex&gt; oauth_config = % GcsSignedUrl.SignBlob.OAuthConfig { service_account : &quot;...&quot; , access_token : &quot;...&quot; } iex&gt; GcsSignedUrl . generate_v4 ( oauth_config , &quot;my-bucket&quot; , &quot;my-object.mp4&quot; , verb : &quot;PUT&quot; , expires : 1800 , headers : [ &quot;Content-Type&quot; : &quot;application/json&quot; ] ) { :ok , &quot;https://storage.googleapis.com/my-bucket/my-object.mp4?X-Goog-Expires=1800...&quot; }","ref":"GcsSignedUrl.html#generate_v4/4","title":"GcsSignedUrl.generate_v4/4","type":"function"},{"doc":"Calculate future timestamp from given hour offset. Examples iex&gt; 10 |&gt; GcsUrlSigner . hours_after 1503599316","ref":"GcsSignedUrl.html#hours_after/1","title":"GcsSignedUrl.hours_after/1","type":"function"},{"doc":"","ref":"GcsSignedUrl.html#t:sign_v2_opts/0","title":"GcsSignedUrl.sign_v2_opts/0","type":"type"},{"doc":"","ref":"GcsSignedUrl.html#t:sign_v4_opts/0","title":"GcsSignedUrl.sign_v4_opts/0","type":"type"},{"doc":"Creates the canonical request accoring to https://cloud.google.com/storage/docs/authentication/canonical-requests","ref":"GcsSignedUrl.CanonicalRequest.html","title":"GcsSignedUrl.CanonicalRequest","type":"module"},{"doc":"","ref":"GcsSignedUrl.CanonicalRequest.html#create/4","title":"GcsSignedUrl.CanonicalRequest.create/4","type":"function"},{"doc":"Defines Google Cloud Storage Signed Url Client","ref":"GcsSignedUrl.Client.html","title":"GcsSignedUrl.Client","type":"module"},{"doc":"Creates a PEM binary from the given client's private_key and decodes it.","ref":"GcsSignedUrl.Client.html#get_decoded_private_key/1","title":"GcsSignedUrl.Client.get_decoded_private_key/1","type":"function"},{"doc":"Initialize GcsSignedUrl.Client with given map, or load a file if called with a path string. Examples iex&gt; service_account = service_account_json_string |&gt; Jason . decode! iex&gt; GcsSignedUrl.Client . load ( service_account ) % GcsSignedUrl.Client { ... } iex&gt; GcsSignedUrl.Client . load ( &quot;/home/alexandrubagu/config/google.json&quot; ) % GcsSignedUrl.Client { ... }","ref":"GcsSignedUrl.Client.html#load/1","title":"GcsSignedUrl.Client.load/1","type":"function"},{"doc":"Initialize GcsSignedUrl.Client using a config file. Examples iex&gt; iex&gt; GcsSignedUrl.Client . load_from_file ( &quot;/home/alexandrubagu/config/google.json&quot; ) % GcsSignedUrl.Client { ... }","ref":"GcsSignedUrl.Client.html#load_from_file/1","title":"GcsSignedUrl.Client.load_from_file/1","type":"function"},{"doc":"","ref":"GcsSignedUrl.Client.html#t:t/0","title":"GcsSignedUrl.Client.t/0","type":"type"},{"doc":"Provides crypto functionality like signing and hashing strings.","ref":"GcsSignedUrl.Crypto.html","title":"GcsSignedUrl.Crypto","type":"module"},{"doc":"Hashed the given string using sha256 algorithm and encode it as lowercase hex string. Examples iex&gt; GcsSignedUrl.Crypto . sha256 ( &quot;foo&quot; ) &quot;1fad6186e41f577a37f56589...&quot;","ref":"GcsSignedUrl.Crypto.html#sha256/1","title":"GcsSignedUrl.Crypto.sha256/1","type":"function"},{"doc":"If you pass a %GcsSignedUrl.Client{} as second argument, this function signs the given string with the given client's private key. If you pass a %GcsSignedUrl.SignBlob.OAuthConfig{} as second argument, this function signs the given string using the signBlob REST API. (see https://cloud.google.com/iam/docs/reference/credentials/rest/v1/projects.serviceAccounts/signBlob ) Examples iex&gt; GcsSignedUrl.Crypto . sign ( &quot;foo&quot; , % GcsSignedUrl.Client { private_key : &quot;-----BEGIN RSA PRIVATE KEY-----...&quot; } ) &quot;...&quot; iex&gt; GcsSignedUrl.Crypto . sign ( &quot;foo&quot; , % GcsSignedUrl.SignBlob.OAuthConfig { access_token : &quot;...&quot; } ) { :ok , &quot;1fad6186e41f577a37f56589...&quot; }","ref":"GcsSignedUrl.Crypto.html#sign/2","title":"GcsSignedUrl.Crypto.sign/2","type":"function"},{"doc":"Transforms headers for a request to representations required by the Google URL signature algorithm","ref":"GcsSignedUrl.Headers.html","title":"GcsSignedUrl.Headers","type":"module"},{"doc":"Creates a %GcsSignedUrl.Headers{} struct from the given headers keyword list. The struct contains the signed headers, such as the canonical headers Examples iex&gt; GcsSignedUrl.Headers . create ( [ &quot;X-Foo&quot; : &quot;foo&quot; , &quot;X-Foo&quot; : &quot;bar&quot; , &quot;Content-Type&quot; : &quot;application/json&quot; ] ) % GcsSignedUrl.Headers { signed : &quot;content-type,x-foo&quot; , canonical :... }","ref":"GcsSignedUrl.Headers.html#create/1","title":"GcsSignedUrl.Headers.create/1","type":"function"},{"doc":"","ref":"GcsSignedUrl.Headers.html#t:t/0","title":"GcsSignedUrl.Headers.t/0","type":"type"},{"doc":"Generates timestamps formatted in iso8601 for usage in signature generation.","ref":"GcsSignedUrl.ISODateTime.html","title":"GcsSignedUrl.ISODateTime","type":"module"},{"doc":"","ref":"GcsSignedUrl.ISODateTime.html#generate/0","title":"GcsSignedUrl.ISODateTime.generate/0","type":"function"},{"doc":"Generates a GcsSignedUrl.DateTime struct from the given timestamp. If no timestamp is given, current time is used.","ref":"GcsSignedUrl.ISODateTime.html#generate/1","title":"GcsSignedUrl.ISODateTime.generate/1","type":"function"},{"doc":"","ref":"GcsSignedUrl.ISODateTime.html#t:t/0","title":"GcsSignedUrl.ISODateTime.t/0","type":"type"},{"doc":"Manages aggregation and formatting of query parameters.","ref":"GcsSignedUrl.QueryString.html","title":"GcsSignedUrl.QueryString","type":"module"},{"doc":"Adds required query parameters for signed URL, sorts them and encodes them as proper query string.","ref":"GcsSignedUrl.QueryString.html#create/6","title":"GcsSignedUrl.QueryString.create/6","type":"function"},{"doc":"","ref":"GcsSignedUrl.QueryString.html#encode_query_rfc3986/1","title":"GcsSignedUrl.QueryString.encode_query_rfc3986/1","type":"function"},{"doc":"https://cloud.google.com/iam/docs/reference/credentials/rest/v1/projects.serviceAccounts/signBlob","ref":"GcsSignedUrl.SignBlob.HTTP.html","title":"GcsSignedUrl.SignBlob.HTTP","type":"module"},{"doc":"Issues a DELETE request to the given url. Returns {:ok, response} if the request is successful, {:error, reason} otherwise. See request/5 for more detailed information.","ref":"GcsSignedUrl.SignBlob.HTTP.html#delete/3","title":"GcsSignedUrl.SignBlob.HTTP.delete/3","type":"function"},{"doc":"Issues a DELETE request to the given url, raising an exception in case of failure. If the request does not fail, the response is returned. See request!/5 for more detailed information.","ref":"GcsSignedUrl.SignBlob.HTTP.html#delete!/3","title":"GcsSignedUrl.SignBlob.HTTP.delete!/3","type":"function"},{"doc":"Issues a GET request to the given url. Returns {:ok, response} if the request is successful, {:error, reason} otherwise. See request/5 for more detailed information.","ref":"GcsSignedUrl.SignBlob.HTTP.html#get/3","title":"GcsSignedUrl.SignBlob.HTTP.get/3","type":"function"},{"doc":"Issues a GET request to the given url, raising an exception in case of failure. If the request does not fail, the response is returned. See request!/5 for more detailed information.","ref":"GcsSignedUrl.SignBlob.HTTP.html#get!/3","title":"GcsSignedUrl.SignBlob.HTTP.get!/3","type":"function"},{"doc":"Issues a HEAD request to the given url. Returns {:ok, response} if the request is successful, {:error, reason} otherwise. See request/5 for more detailed information.","ref":"GcsSignedUrl.SignBlob.HTTP.html#head/3","title":"GcsSignedUrl.SignBlob.HTTP.head/3","type":"function"},{"doc":"Issues a HEAD request to the given url, raising an exception in case of failure. If the request does not fail, the response is returned. See request!/5 for more detailed information.","ref":"GcsSignedUrl.SignBlob.HTTP.html#head!/3","title":"GcsSignedUrl.SignBlob.HTTP.head!/3","type":"function"},{"doc":"Issues an OPTIONS request to the given url. Returns {:ok, response} if the request is successful, {:error, reason} otherwise. See request/5 for more detailed information.","ref":"GcsSignedUrl.SignBlob.HTTP.html#options/3","title":"GcsSignedUrl.SignBlob.HTTP.options/3","type":"function"},{"doc":"Issues a OPTIONS request to the given url, raising an exception in case of failure. If the request does not fail, the response is returned. See request!/5 for more detailed information.","ref":"GcsSignedUrl.SignBlob.HTTP.html#options!/3","title":"GcsSignedUrl.SignBlob.HTTP.options!/3","type":"function"},{"doc":"Issues a PATCH request to the given url. Returns {:ok, response} if the request is successful, {:error, reason} otherwise. See request/5 for more detailed information.","ref":"GcsSignedUrl.SignBlob.HTTP.html#patch/4","title":"GcsSignedUrl.SignBlob.HTTP.patch/4","type":"function"},{"doc":"Issues a PATCH request to the given url, raising an exception in case of failure. If the request does not fail, the response is returned. See request!/5 for more detailed information.","ref":"GcsSignedUrl.SignBlob.HTTP.html#patch!/4","title":"GcsSignedUrl.SignBlob.HTTP.patch!/4","type":"function"},{"doc":"Issues a POST request to the given url. Returns {:ok, response} if the request is successful, {:error, reason} otherwise. See request/5 for more detailed information.","ref":"GcsSignedUrl.SignBlob.HTTP.html#post/4","title":"GcsSignedUrl.SignBlob.HTTP.post/4","type":"function"},{"doc":"Issues a POST request to the given url, raising an exception in case of failure. If the request does not fail, the response is returned. See request!/5 for more detailed information.","ref":"GcsSignedUrl.SignBlob.HTTP.html#post!/4","title":"GcsSignedUrl.SignBlob.HTTP.post!/4","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_headers/1 .","ref":"GcsSignedUrl.SignBlob.HTTP.html#process_headers/1","title":"GcsSignedUrl.SignBlob.HTTP.process_headers/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_request_body/1 .","ref":"GcsSignedUrl.SignBlob.HTTP.html#process_request_body/1","title":"GcsSignedUrl.SignBlob.HTTP.process_request_body/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_request_headers/1 .","ref":"GcsSignedUrl.SignBlob.HTTP.html#process_request_headers/1","title":"GcsSignedUrl.SignBlob.HTTP.process_request_headers/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_request_options/1 .","ref":"GcsSignedUrl.SignBlob.HTTP.html#process_request_options/1","title":"GcsSignedUrl.SignBlob.HTTP.process_request_options/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_request_params/1 .","ref":"GcsSignedUrl.SignBlob.HTTP.html#process_request_params/1","title":"GcsSignedUrl.SignBlob.HTTP.process_request_params/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_request_url/1 .","ref":"GcsSignedUrl.SignBlob.HTTP.html#process_request_url/1","title":"GcsSignedUrl.SignBlob.HTTP.process_request_url/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_response/1 .","ref":"GcsSignedUrl.SignBlob.HTTP.html#process_response/1","title":"GcsSignedUrl.SignBlob.HTTP.process_response/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_response_body/1 .","ref":"GcsSignedUrl.SignBlob.HTTP.html#process_response_body/1","title":"GcsSignedUrl.SignBlob.HTTP.process_response_body/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_response_chunk/1 .","ref":"GcsSignedUrl.SignBlob.HTTP.html#process_response_chunk/1","title":"GcsSignedUrl.SignBlob.HTTP.process_response_chunk/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_response_headers/1 .","ref":"GcsSignedUrl.SignBlob.HTTP.html#process_response_headers/1","title":"GcsSignedUrl.SignBlob.HTTP.process_response_headers/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_response_status_code/1 .","ref":"GcsSignedUrl.SignBlob.HTTP.html#process_response_status_code/1","title":"GcsSignedUrl.SignBlob.HTTP.process_response_status_code/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_status_code/1 .","ref":"GcsSignedUrl.SignBlob.HTTP.html#process_status_code/1","title":"GcsSignedUrl.SignBlob.HTTP.process_status_code/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_url/1 .","ref":"GcsSignedUrl.SignBlob.HTTP.html#process_url/1","title":"GcsSignedUrl.SignBlob.HTTP.process_url/1","type":"function"},{"doc":"Issues a PUT request to the given url. Returns {:ok, response} if the request is successful, {:error, reason} otherwise. See request/5 for more detailed information.","ref":"GcsSignedUrl.SignBlob.HTTP.html#put/4","title":"GcsSignedUrl.SignBlob.HTTP.put/4","type":"function"},{"doc":"Issues a PUT request to the given url, raising an exception in case of failure. If the request does not fail, the response is returned. See request!/5 for more detailed information.","ref":"GcsSignedUrl.SignBlob.HTTP.html#put!/4","title":"GcsSignedUrl.SignBlob.HTTP.put!/4","type":"function"},{"doc":"Issues an HTTP request using an HTTPoison.Request struct. This function returns {:ok, response} , {:ok, async_response} , or {:ok, maybe_redirect} if the request is successful, {:error, reason} otherwise. Redirect handling If the option :follow_redirect is given, HTTP redirects are automatically follow if the method is set to :get or :head and the response's status_code is 301 , 302 or 307 . If the method is set to :post , then the only status_code that get's automatically followed is 303 . If any other method or status_code is returned, then this function returns a returns a {:ok, %HTTPoison.MaybeRedirect{}} containing the redirect_url for you to re-request with the method set to :get . Examples request = % HTTPoison.Request { method : :post , url : &quot;https://my.website.com&quot; , body : &quot;{ \\&quot; foo \\&quot; : 3}&quot; , headers : [ { &quot;Accept&quot; , &quot;application/json&quot; } ] } request ( request )","ref":"GcsSignedUrl.SignBlob.HTTP.html#request/1","title":"GcsSignedUrl.SignBlob.HTTP.request/1","type":"function"},{"doc":"Issues an HTTP request with the given method to the given url. This function is usually used indirectly by get/3 , post/4 , put/4 , etc Args: method - HTTP method as an atom ( :get , :head , :post , :put , :delete , etc.) url - target url as a binary string or char list body - request body. See more below headers - HTTP headers as an orddict (e.g., [{&quot;Accept&quot;, &quot;application/json&quot;}] ) options - Keyword list of options Body: see type HTTPoison.Request Options: see type HTTPoison.Request This function returns {:ok, response} , {:ok, async_response} , or {:ok, maybe_redirect} if the request is successful, {:error, reason} otherwise. Redirect handling If the option :follow_redirect is given, HTTP redirects are automatically follow if the method is set to :get or :head and the response's status_code is 301 , 302 or 307 . If the method is set to :post , then the only status_code that get's automatically followed is 303 . If any other method or status_code is returned, then this function returns a returns a {:ok, %HTTPoison.MaybeRedirect{}} containing the redirect_url for you to re-request with the method set to :get . Examples request ( :post , &quot;https://my.website.com&quot; , &quot;{ \\&quot; foo \\&quot; : 3}&quot; , [ { &quot;Accept&quot; , &quot;application/json&quot; } ] )","ref":"GcsSignedUrl.SignBlob.HTTP.html#request/5","title":"GcsSignedUrl.SignBlob.HTTP.request/5","type":"function"},{"doc":"Issues an HTTP request with the given method to the given url, raising an exception in case of failure. request!/5 works exactly like request/5 but it returns just the response in case of a successful request, raising an exception in case the request fails.","ref":"GcsSignedUrl.SignBlob.HTTP.html#request!/5","title":"GcsSignedUrl.SignBlob.HTTP.request!/5","type":"function"},{"doc":"Starts HTTPoison and its dependencies.","ref":"GcsSignedUrl.SignBlob.HTTP.html#start/0","title":"GcsSignedUrl.SignBlob.HTTP.start/0","type":"function"},{"doc":"Requests the next message to be streamed for a given HTTPoison.AsyncResponse . See request!/5 for more detailed information.","ref":"GcsSignedUrl.SignBlob.HTTP.html#stream_next/1","title":"GcsSignedUrl.SignBlob.HTTP.stream_next/1","type":"function"},{"doc":"","ref":"GcsSignedUrl.SignBlob.HTTP.html#t:body/0","title":"GcsSignedUrl.SignBlob.HTTP.body/0","type":"type"},{"doc":"","ref":"GcsSignedUrl.SignBlob.HTTP.html#t:headers/0","title":"GcsSignedUrl.SignBlob.HTTP.headers/0","type":"type"},{"doc":"","ref":"GcsSignedUrl.SignBlob.HTTP.html#t:method/0","title":"GcsSignedUrl.SignBlob.HTTP.method/0","type":"type"},{"doc":"","ref":"GcsSignedUrl.SignBlob.HTTP.html#t:options/0","title":"GcsSignedUrl.SignBlob.HTTP.options/0","type":"type"},{"doc":"","ref":"GcsSignedUrl.SignBlob.HTTP.html#t:params/0","title":"GcsSignedUrl.SignBlob.HTTP.params/0","type":"type"},{"doc":"","ref":"GcsSignedUrl.SignBlob.HTTP.html#t:request/0","title":"GcsSignedUrl.SignBlob.HTTP.request/0","type":"type"},{"doc":"","ref":"GcsSignedUrl.SignBlob.HTTP.html#t:url/0","title":"GcsSignedUrl.SignBlob.HTTP.url/0","type":"type"},{"doc":"Defines Google Cloud OAuth2 Config. The service account should be an email or unique ID of an existing Google service account GSA_SIGNER . The access token should belong to a Google service account GSA_AUTH . In this scenario, the GSA_AUTH acts as GSA_SIGNER and signs the given string on his behalf. This requires the GSA_AUTH go have the Google IAM permission iam.serviceAccounts.signBlob on the GSA_SIGNER , e.g. by giving it the built in role roles/iam.serviceAccountTokenCreator on GSA_SIGNER .","ref":"GcsSignedUrl.SignBlob.OAuthConfig.html","title":"GcsSignedUrl.SignBlob.OAuthConfig","type":"module"},{"doc":"","ref":"GcsSignedUrl.SignBlob.OAuthConfig.html#t:t/0","title":"GcsSignedUrl.SignBlob.OAuthConfig.t/0","type":"type"},{"doc":"Generates the string-to-sign and the URL the signature is being signed.","ref":"GcsSignedUrl.StringToSign.html","title":"GcsSignedUrl.StringToSign","type":"module"},{"doc":"Creates the string to sign according to https://cloud.google.com/storage/docs/access-control/signed-urls-v2 and returns it together with a template for the URL that is being signed. The URL template contains a placeholder #SIGNATURE# for the actual signature.","ref":"GcsSignedUrl.StringToSign.html#generate_v2/4","title":"GcsSignedUrl.StringToSign.generate_v2/4","type":"function"},{"doc":"Creates the string to sign according to https://cloud.google.com/storage/docs/authentication/signatures#string-to-sign and returns it together with a template of the URL that is being signed. The URL template contains a placeholder #SIGNATURE# for the actual signature.","ref":"GcsSignedUrl.StringToSign.html#generate_v4/4","title":"GcsSignedUrl.StringToSign.generate_v4/4","type":"function"},{"doc":"","ref":"GcsSignedUrl.StringToSign.html#t:t/0","title":"GcsSignedUrl.StringToSign.t/0","type":"type"},{"doc":"","ref":"readme.html","title":"gcs_signed_url - Create Signed URLs for Google Cloud Storage","type":"extras"},{"doc":"This package works with Elixir &gt;= 1.8 and Erlang/OTP &gt;= 22.3","ref":"readme.html#important","title":"gcs_signed_url - Create Signed URLs for Google Cloud Storage - Important","type":"extras"},{"doc":"Add gcs_signed_url to your list of dependencies in mix.exs : def deps do [ { :gcs_signed_url , &quot;~&gt; 0.4&quot; } ] end","ref":"readme.html#hex-installation","title":"gcs_signed_url - Create Signed URLs for Google Cloud Storage - Hex Installation","type":"extras"},{"doc":"This library creates signed URLs for the Google Cloud Storage in three steps: Create a string to sign (use V4 signing process - V2 signing process is stil supported but deprecated) Sign the string to sign with the private key of a Google service account (GSA) Form the URL including the signature The actual signing can be done on-premise on the machine your application is executed or it can be delegated to the Google IAM SignBlob API. The method of signing depends on your setup. Both methods work for creating V4 or V2 (deprecated) signatures. Google IAM SingBlob API - Preferred on the GKE If your application runs on the Google Kubernetes Engine, the preferred way of accessing Google Cloud services is through a Workload Identity . In this scenario, you run your application under a Kubernetes service account (KSA) which is related to a GSA. Using Goth , you would get an OAuth2 access token and use it to create a signed URL through the SignBlob API. In this scenario, the GSA you get the access token for ( GSA_AUTH ) acts as a Google Service Account GSA_SIGNER and signs the URL on his behalf. This requires the GSA_AUTH go have the Google IAM permission iam.serviceAccounts.signBlob on the GSA_SIGNER , e.g. by giving it the built in role roles/iam.serviceAccountTokenCreator on GSA_SIGNER . GSA_AUTH and GSA_SIGNER can also be the same service account in which case he needs to have the permission iam.serviceAccounts.signBlob on itself. Example iex&gt; { :ok , %{ token : access_token } } = Goth.Token . for_scope ( &quot;https://www.googleapis.com/auth/devstorage.read_write&quot; ) iex&gt; oauth_config = % GcsSignedUrl.SignBlob.OAuthConfig { service_account : &quot;project@gcs_signed_url.iam.gserviceaccount.com&quot; , access_token : access_token } iex&gt; GcsSignedUrl . generate_v4 ( oauth_config , &quot;my-bucket&quot; , &quot;my-object.jpg&quot; , verb : &quot;PUT&quot; , expires : 1800 , headers : [ &quot;Content-Type&quot; : &quot;application/jpeg&quot; ] ) { :ok , &quot;https://storage.googleapis.com/my-bucket/my-object.jpg?X-Goog-Expires=1800...&quot; } On-Premise Signing In this scenario you have a service account key in form of a JSON file on your machine. The library will use the private key to create the signature, no network calls are needed. Load the client iex&gt; GcsSignedUrl.Client . load_from_file ( &quot;/home/alexandrubagu/config/google.json&quot; ) or iex&gt; service_account = service_account_json_string |&gt; Jason . decode! iex&gt; GcsSignedUrl.Client . load ( service_account ) Generate signed url GcsSignedUrl . generate_v4 ( client , &quot;my-bucket&quot; , &quot;my-object.mp4&quot; ) GcsSignedUrl . generate_v4 ( client , &quot;my-bucket&quot; , &quot;my-object.mp4&quot; , expires : 3 * 3600 ) # 3 hours ` ` `","ref":"readme.html#usage","title":"gcs_signed_url - Create Signed URLs for Google Cloud Storage - Usage","type":"extras"},{"doc":"All notable changes to this project will be documented in this file. The format is based on Keep a Changelog .","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"","ref":"changelog.html#unreleased","title":"Changelog - Unreleased","type":"extras"},{"doc":"Chores Several dependencies where updated. See the release page for more information.","ref":"changelog.html#0-4-6-2023-03-27","title":"Changelog - [0.4.6] - 2023-03-27","type":"extras"},{"doc":"Added Add optional :host to generate_v4/3 opts. See Domain-named buckets in the Google Cloud docs for more info. [ #69 ] Changed Use Kernel.hd/1 insead of (fn [x] -&gt; x end).() to pick the first (only) item in the list.","ref":"changelog.html#0-4-5-2022-08-18","title":"Changelog - [0.4.5] - 2022-08-18","type":"extras"},{"doc":"Deprecated Deprecated: V2 signing process is considered legacy. Deprecating GcsSignedUrl.generate/4 in favor of GcsSignedUrl.generate_v4/4","ref":"changelog.html#0-4-4-2021-11-19","title":"Changelog - [0.4.4] - 2021-11-19","type":"extras"},{"doc":"Changed Fix: Use RFC 3986 query encoding #33E Fix: Changed domain of Google API endpoint for signBlob from content-iamcredentials.googleapis.com to iamcredentials.googleapis.com Docs: use correct auth scope in READM Chores: Bump httpoison from 1.7.0 to 1.8.0 Chores: Bump excoveralls from 0.13.3 to 0.13.4 Chores: Bump credo from 1.5.3 to 1.5.4","ref":"changelog.html#0-4-3-2021-06-11","title":"Changelog - [0.4.3] - 2021-06-11","type":"extras"},{"doc":"Added Github Workflows and Dependabot configuration Changed URL encode the signature in V2 algorithm (#7, #16) Misc. Markdown format and module config changes for HTML doc generation","ref":"changelog.html#0-4-2-2020-10-20","title":"Changelog - [0.4.2] - 2020-10-20","type":"extras"},{"doc":"Added this changelog ;) Changed Better README.md and add README.md to hex docs Changes regarding support for Elixir 1.11","ref":"changelog.html#0-4-1-2020-10-20","title":"Changelog - [0.4.1] - 2020-10-20","type":"extras"},{"doc":"Added Support for signing strings via IAM REST API ( #6 ] Removed Changed","ref":"changelog.html#0-4-0-2020-05-04","title":"Changelog - [0.4.0] - 2020-05-04","type":"extras"}]